    device zxspectrum128

entrya=$100
;    macro   sectors datab,datae
; IF low (datae-datab)=0
;   db high (datae-datab)
; ELSE
;   db (1+high (datae-datab))
; ENDIF
;    endm

    org entrya-14*1-9
scl_b:
;header_b:
 db "SINCLAIR"
 db 1; filez
;-1st
file1:
;    12345678t
 db "Cubeon  B"
 dw basic_e-basic_b-4;start
 dw basic_e-basic_b-4;length?
 ;sectors basic_b,scl_e;sectors
 db (scl_e-basic_b+255)/256


 org entrya
basic_b:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA
 
    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; L O A D E R ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    macro trload mema,secs
 ld hl,mema
 ld bc,5+secs*256
 ld de,(#5CF4)
 call $3d13
    endm

x2:
 di
 ld sp,$5FFF
    ld a,$10,bc,$7FFD:out (c),a
	trload $BF00,1
	jp $BF00

my_e:

;------------------------------
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
;border not pi
 db 231,195,167
 db #3A; :
 
 db #20,#FD,#B0,#22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
basic_e:

;sectors
 align 256
 incbin "ldr.cod"

 align 256
 incbin "001!   DATA.bin"
 align 256
 incbin "002!   data01.bin"
 align 256
 incbin "003!   data02.bin"
 align 256
 incbin "004!   data03.bin"
 align 256
 incbin "005!   data04.bin"
 align 256
 incbin "006!   data05.bin"
 align 256
 incbin "007!   data06.bin"
 align 256
 incbin "008!   data07.bin"
 align 256
 incbin "009!   data08.bin"
 align 256
 incbin "010!   data09.bin"
 align 256
 incbin "011!   data10.bin"
 align 256
 incbin "012!   data11.bin"
 align 256
 incbin "013!   data12.bin"
 
 align 256

scl_e:
    savebin "huj.scl",scl_b,scl_e-scl_b

    LUA

    local fp
    local checksum
-- never rename file
    fp = assert(io.open("huj.scl", "rb"))
    checksum=0
    while true do
        local byte = fp:read(1)
        if byte==nil then
            break
        end
        checksum=checksum+string.byte(byte)
    end
    assert(fp:close())
    print("writing",string.format("%08X",checksum))
    fp = assert(io.open("huj.scl", "a"))

    for i=1,4 do
        fp:write(string.char(checksum%256))
        checksum=math.floor(checksum/256)
    end

    assert(fp:close())

    local ss=""
    for i=0,7,1 do
        ss=ss..string.char( sj.get_byte( sj.get_label("file1")+i ) )
    end

    ss=ss:match "^%s*(.-)%s*$"
--  print(ss)
    os.rename("huj.scl", ss..".scl")

    ENDLUA
